environment noecho
compute runno=10

compute [vect[str]] stypes =    ||'lfprsa','gs','ts','pop','popn'||;  
compute ae_poly_degree=-1
compute ce_poly_degree=-1
compute x_cohorts_beg=5
compute x_cohorts_end=5
compute reg_cohort_num=10
compute cohort_ex = 2; * cohort extension type (0=regress,1=last observed,2=regress through est/last est)
compute logit=1
compute weighted=1; * 1=weighted regression
compute smoothed=1; * 1=smoothed cohorts
compute errmod=0; * 0=IID, 1=AR1 (homogenous), 2=AR1 (heterogenous)
compute stage2int=1;
compute dographs=0;
compute debug=0;


decl vect[int] allages(64); ewise allages(i) = 15+i; * (Ages 16-79)
decl vect[int] educages(53); ewise educages(i) = 26+i; * (Ages 27-79)
decl vect[int] ssages(18); ewise ssages(i) = 61+i; * (Ages 62-79)
decl vect[int] lfages(25); ewise lfages(i) = 54+i; * (Ages 55-79) 
decl vect[int] wedages(44); ewise wedages(i) = 17+i; * (Ages 18-61)
decl vect[int] kidages(28); ewise kidages(i) = 17+i; * (Ages 18-45)
decl vect[int] teens(4); ewise teens(i) = 15+i; * (Ages 16-19)
decl vect[int] young(2); ewise young(i) = 15+i; * (Ages 16-17)
decl vect[int] disage(35); ewise disage(i) = 29+i; * (Ages 30-64)

compute [vector[str]] rhsdesc    = ||"'+' Component of CBO Unemployment Gap", $
		      		     "'-' Component of CBO Unemployment Gap", $
				     'Married with Child<6 (HP)', $
				     'Married without Child<6 (HP)', $
				     'Unmarried with Child<6 (HP)', $
                                     'Wage Ratio (Median - HP)', $
                                     'Minimum Wage/AHE', $
				     'SA Detrended Personal Bankruptcies (Ratio)', $
				     'Percent with College Degree', $
                                     'Disability Rate', $
				     'Social Security Payout', $
				     'Life Expectancy', $
                                     'Summer to Non Summer Enrollment' $
				   ||;
compute [vec[str]] rhsvar        = || 'cbogaplp', 'cbogapln','mw6hp'  , 'mwo6hp', 'umw6hp','mhehp' ,'mwgahe','clpbrdq2','coll'   ,'dis3'  , 'ss'   , 'life' ,'enroll'||;
compute [vec[int]] rhsvartype    = || 0         , 0         , 4       , 4       , 4       , 5      , 4      , 0        , 4       , 4      , 1      , 4      , 4      ||;
compute [vec[int]] rhsvarsex     = || 0         , 0         , 1       , 1       , 1       , 0      , 0      , 0        , 0       , 0      , 0      , 0      , 0      ||;
compute [vec[int]] rhsvarnorm    = || 0         , 0         , 1       , 1       , 1       , 1      , 1      , 1        , 1       , 1      , 1      , 1      , 1      ||;
compute [vec[int]] rhsvarcyc	 = || 1         , 1         , 0       , 0       , 0       , 0      , 0      , 1        , 0       , 0      , 0      , 0      , 0      ||;
compute [vec[int]] rhsvarstage   = || 1         , 1         , 1       , 1       , 1       , 1      , 1      , 1        , 1       , 1      , 1      , 1      , 2      ||;
compute [vec[vec[int]]] rhsages  = ||allages    , allages   , kidages , wedages , kidages , teens  , teens  ,allages   , educages, disage , ssages , lfages , teens  ||;
declare vec[vec[int]] rhslagl(%rows(rhsvar))
compute %do(i,1,%rows(rhsvar),rhslagl(i)=||0||)
compute rhslagl(1) = ||12,24,36||
compute rhslagl(2) = ||12,24,36||

* INFORMATION FOR FREQUENCY LOOP;
compute [vect[str]] fsv =     ||'m','q'||
compute [vect[int]] npersv =  ||12,  4||
compute [vect[int]] syearv =  ||1976,1976||
compute [vect[int]] sperv =   ||1,   1||
compute [vect[int]] eyearv =  ||2014,2014||
compute [vect[int]] eperv =   ||6,   2||
compute [vect[int]] feyearv = ||2024,2024||
compute [vect[int]] feperv =  ||12,  4||

source 'lfpr.prg'
