set more off
#delim cr
version 8
pause on

clear

foreach m in 01 02 03 04 05 06 07 08 09 10 11 12 {

gzuse cpsb`1'`m'.dta.gz, clear


rename peage age
rename pesex sex
keep if age>=16 & age<=24

rename peschft ftpt
rename peschlvl schlvl
rename pwsswgt finwgt
rename peschenr schenr

replace schenr=0 if schenr==. | schenr==2

gen school=1 if ftpt==1
replace school=2 if ftpt==2
replace school=0 if school==.
drop ftpt
rename school ftpt

gen empstat=1 if pemlr==1 | pemlr==2
replace empstat=2 if pemlr==3 | pemlr==4
replace empstat=0 if empstat==.

replace schlvl=0 if schlvl!=1 & schlvl!=2

replace finwgt=finwgt/12

gen ageg=1 if age>=16 & age<=18
replace ageg=2 if age>=19 & age<=21
replace ageg=3 if age>=22 & age<=24

sort sex ageg empstat schenr schlvl ftpt 

keep sex ageg empstat schenr schlvl ftpt finwgt

collapse (sum) finwgt, by(sex ageg empstat schenr schlvl ftpt)
gen year=`1'
gen month=`m'

compress

tempfile temp`m'
save `temp`m'', replace
}

use `temp01', clear
foreach m in 02 03 04 05 06 07 08 09 10 11 12 {
append using `temp`m''
}

save morg_cleaned_youth_`1', replace
 

